import json
import os
from keygen import verify_signature

POSTS_FILE = "forum.db"

class Forum:
    def __init__(self):
        if not os.path.exists(POSTS_FILE):
            with open(POSTS_FILE, "w") as f:
                json.dump([], f)

    def receive_post(self, data):
        try:
            post = json.loads(data)
            if verify_signature(post["content"], post["sig"], post["pub"]):
                posts = self.load_posts()
                if post not in posts:
                    posts.append(post)
                    self.save_posts(posts)
                    print("New verified post received.")
        except Exception as e:
            print(f"Post verification failed: {e}")

    def load_posts(self):
        with open(POSTS_FILE) as f:
            return json.load(f)

    def save_posts(self, posts):
        with open(POSTS_FILE, "w") as f:
            json.dump(posts, f)
